stages:
  - testing # Запуск тестов
  - history_copy # Копирование результата тестов из предыдущего запуска тестов
  - reports # Генерация отчета
  - deploy # Публикация отчета на gitlab pages

docker_job:
  stage: testing
  image: python:3.8-alpine
  before_script:
    - pip install -r requirements.txt
  script:
    - pytest -n=4 --alluredir=./allure-results tests/

  allow_failure: true
  artifacts:
    when: always
    paths:
      - ./allure-results
    expire_in: 1 day

history_job:
  stage: history_copy
  image: praqma/network-multitool
  script:
    - 'curl --location --output artifacts.zip --header "PRIVATE-TOKEN: glpat-JmxQdxXqJ2mXEAxjwxMr" "https://gitlab.com/api/v4/projects/44851352/jobs/artifacts/master/download?job=pages"'
    #- curl --location --output artifacts.zip "https://gitlab.com/api/v4/projects/44851352/jobs/artifacts/master/download?job=pages&job_token=$CI_JOB_TOKEN"
    #- apk add unzip
    - pwd 
    - ls -la
    - unzip artifacts.zip
    - chmod -R 777 public
    - cp -r ./public/history ./allure-results
  allow_failure: true
  artifacts: 
    paths:
      - ./allure-results
    expire_in: 1 day
  rules:
    - when: always

allure_job:
  stage: reports
  image: frankescobar/allure-docker-service
  script:
     - allure generate -c ./allure-results -o ./allure-report
  artifacts:
    paths:
      - ./allure-results
      - ./allure-report
    expire_in: 1 day
  rules:
    - when: always

pages:
  stage: deploy
  script:
    - mkdir public
    - mv ./allure-report/* public
  artifacts:
    paths:
      - public
  rules:
    - when: always
